diff --git a/src/backend/commands/pipelinecmds.c b/src/backend/commands/pipelinecmds.c
index edbded860..096814eb4 100644
--- a/src/backend/commands/pipelinecmds.c
+++ b/src/backend/commands/pipelinecmds.c
@@ -65,8 +65,11 @@
 #define DEFAULT_TYPEMOD -1
 
 #define OPTION_FILLFACTOR "fillfactor"
+#define OPTION_STEPFACTOR "stepfactor"
 
+/* guc params */
 int continuous_view_fillfactor;
+int sliding_window_step_factor;
 
 static ColumnDef *
 make_cv_columndef(char *name, Oid type, Oid typemod)
@@ -92,12 +95,12 @@ make_cv_columndef(char *name, Oid type, Oid typemod)
 }
 
 /*
- * has_fillfactor
+ * get_option
  *
- * Returns true if a fillfactor option is included in the given WITH options
+ * Returns the given option or NULL if it wasn't supplied
  */
-static bool
-has_fillfactor(List *options)
+static DefElem *
+get_option(List *options, char *name)
 {
 	ListCell *lc;
 
@@ -109,11 +112,11 @@ has_fillfactor(List *options)
 			continue;
 
 		de = (DefElem *) lfirst(lc);
-		if (de->defname && pg_strcasecmp(de->defname, OPTION_FILLFACTOR) == 0)
-			return true;
+		if (de->defname && pg_strcasecmp(de->defname, name) == 0)
+			return de;
 	}
 
-	return false;
+	return NULL;
 }
 
 /*
@@ -418,11 +421,36 @@ ExecCreateContViewStmt(CreateContViewStmt *stmt, const char *querystring)
 	ContAnalyzeContext *context;
 	ContinuousView *cv;
 	Oid cvid;
+	DefElem *step;
+	int savestep = sliding_window_step_factor;
 
 	Assert(((SelectStmt *) stmt->query)->forContinuousView);
 
 	view = stmt->into->rel;
 
+	/*
+	 * If the user supplied a step factor, override the global default with it
+	 */
+	step = get_option(stmt->into->options, OPTION_STEPFACTOR);
+	if (step)
+	{
+		if (!IsA(step->arg, Integer))
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					errmsg("sliding-window stepfactor must be an integer")));
+
+		sliding_window_step_factor = intVal(step->arg);
+		if (sliding_window_step_factor < 1 || sliding_window_step_factor > 100)
+			ereport(ERROR,
+					(errcode(ERRCODE_INVALID_PARAMETER_VALUE),
+					errmsg("sliding-window stepfactor must be an integer between 1 and 100")));
+
+		savestep = sliding_window_step_factor;
+
+		/* remove the option now because it won't be recognized later on */
+		stmt->into->options = list_delete(stmt->into->options, step);
+	}
+
 	/*
 	 * Check if CV already exists?
 	 */
@@ -459,6 +487,7 @@ ExecCreateContViewStmt(CreateContViewStmt *stmt, const char *querystring)
 	 * that need to be created in the underlying matrel.
 	 */
 	workerselect = TransformSelectStmtForContProcess(matrel, cont_select, &viewselect, Worker);
+	sliding_window_step_factor = savestep;
 
 	query = parse_analyze(copyObject(workerselect), cont_select_sql, 0, 0);
 	tlist = query->targetList;
@@ -498,11 +527,11 @@ ExecCreateContViewStmt(CreateContViewStmt *stmt, const char *querystring)
 		tableElts = lappend(tableElts, coldef);
 	}
 
-	if (!has_fillfactor(stmt->into->options))
+	if (!get_option(stmt->into->options, OPTION_FILLFACTOR))
 		stmt->into->options = add_default_fillfactor(stmt->into->options);
 
 	/*
-	 * Create the actual underlying materialzation relation.
+	 * Create the actual underlying materialization relation.
 	 */
 	create_stmt = makeNode(CreateStmt);
 	create_stmt->relation = matrel;
diff --git a/src/backend/nodes/makefuncs.c b/src/backend/nodes/makefuncs.c
index da59c580b..61c9b2e38 100644
--- a/src/backend/nodes/makefuncs.c
+++ b/src/backend/nodes/makefuncs.c
@@ -552,5 +552,6 @@ makeFuncCall(List *name, List *args, int location)
 	n->func_variadic = false;
 	n->over = NULL;
 	n->location = location;
+
 	return n;
 }
diff --git a/src/backend/pipeline/cont_analyze.c b/src/backend/pipeline/cont_analyze.c
index 340a93cb3..7e496214e 100644
--- a/src/backend/pipeline/cont_analyze.c
+++ b/src/backend/pipeline/cont_analyze.c
@@ -22,6 +22,7 @@
 #include "catalog/pipeline_combine_fn.h"
 #include "catalog/pipeline_query_fn.h"
 #include "catalog/pipeline_stream_fn.h"
+#include "commands/pipelinecmds.h"
 #include "lib/stringinfo.h"
 #include "nodes/makefuncs.h"
 #include "nodes/nodeFuncs.h"
@@ -484,28 +485,44 @@ find_clock_timestamp_expr(Node *node, ContAnalyzeContext *context)
 	return raw_expression_tree_walker(node, find_clock_timestamp_expr, (void *) context);
 }
 
-static char *
-get_truncation_from_interval_expr(Node *node)
+/*
+ * get_step_size_interval_expr
+ *
+ * Returns a constant representing the step size to use for the given window.
+ */
+static A_Const *
+get_step_size_interval_expr(Node *node)
 {
 	Expr *expr = (Expr *) transformExpr(make_parsestate(NULL), node, EXPR_KIND_WHERE);
-	Const *c;
-	Interval *i;
+	Const *window;
+	Interval *step;
+	Interval min_step;
+	float8 factor = (float8) sliding_window_step_factor / (float8) 100.0;
+	A_Const *result = makeNode(A_Const);
+	Value *v;
+	char *str;
+	Datum cmp;
+
+	MemSet(&min_step, 0, sizeof(Interval));
+	min_step.time = 1000 * 1000;
 
 	Assert(IsA(expr, Const));
-	c = (Const *) expr;
-	Assert(c->consttype == INTERVALOID);
+	window = (Const *) expr;
+	Assert(window->consttype == INTERVALOID);
 
-	i = (Interval *) c->constvalue;
+	/* We make the step size some percentage of the total window width */
+	step = (Interval *) DirectFunctionCall2(interval_mul, window->constvalue, Float8GetDatum(factor));
 
-	/* We make the step size one unit smaller than the granularity of the window size unit */
-	if (i->month)
-		return DATE_TRUNC_DAY;
-	else if (i->day)
-		return DATE_TRUNC_HOUR;
-	else if (i->time > HOUR_USEC)
-		return DATE_TRUNC_MINUTE;
+	cmp = (Datum) DirectFunctionCall2(interval_cmp, (Datum) step, (Datum) &min_step);
+	if (DatumGetInt32(cmp) < 0)
+		step = &min_step;
 
-	return DATE_TRUNC_SECOND;
+	str = (char *) DirectFunctionCall1(interval_out, (Datum) step);
+
+	v = makeString(str);
+	result->val = *v;
+
+	return result;
 }
 
 static ColumnRef *
@@ -513,7 +530,6 @@ validate_window_timestamp_expr(SelectStmt *stmt, Node *node, ContAnalyzeContext
 {
 	Node *col = node;
 	bool saw_expr = false;
-	bool saw_trunc = false;
 
 	context->cols = NIL;
 	collect_types_and_cols(node, context);
@@ -540,16 +556,14 @@ validate_window_timestamp_expr(SelectStmt *stmt, Node *node, ContAnalyzeContext
 			FuncCall *fc = (FuncCall *) col;
 			char *name = NameListToString(fc->funcname);
 
-			if (pg_strcasecmp(name, DATE_FLOOR) == 0 ||
+			if (!(pg_strcasecmp(name, DATE_FLOOR) == 0 ||
 					pg_strcasecmp(name, DATE_TRUNC) == 0 ||
 					pg_strcasecmp(name, DATE_TRUNC_YEAR) == 0 ||
 					pg_strcasecmp(name, DATE_TRUNC_MONTH) == 0 ||
 					pg_strcasecmp(name, DATE_TRUNC_DAY) == 0 ||
 					pg_strcasecmp(name, DATE_TRUNC_HOUR) == 0 ||
 					pg_strcasecmp(name, DATE_TRUNC_MINUTE) == 0 ||
-					pg_strcasecmp(name, DATE_TRUNC_SECOND) == 0)
-				saw_trunc = true;
-			else
+					pg_strcasecmp(name, DATE_TRUNC_SECOND) == 0))
 				return NULL;
 
 			/* Date truncation should happen at the top level */
@@ -584,23 +598,6 @@ validate_window_timestamp_expr(SelectStmt *stmt, Node *node, ContAnalyzeContext
 		return NULL;
 	}
 
-	if (context->is_sw && !saw_trunc)
-	{
-		A_Expr *ct_expr = (A_Expr *) context->expr;
-		TypeCast *c;
-		char *fname;
-
-		Assert(ct_expr && IsA(ct_expr, A_Expr));
-
-		c = (TypeCast *) ct_expr->rexpr;
-		Assert(IsA(c, TypeCast) && IsA(c->arg, A_Const));
-		fname = get_truncation_from_interval_expr((Node *) c);
-
-		ereport(NOTICE,
-				(errmsg("window width is \"%s\" with a step size of \"1 %s\"", strVal(&((A_Const *) c->arg)->val), fname),
-				errhint("Use a datetime truncation function if you want to explicitly set the step size.")));
-	}
-
 	return (ColumnRef *) col;
 }
 
@@ -2012,15 +2009,16 @@ truncate_timestamp_field(Node *time, A_Expr *sw_expr, ContAnalyzeContext *contex
 		if (sw_expr)
 		{
 			A_Expr *ct_expr;
-			char *fname;
+			A_Const *step;
 
 			if (equal(sw_expr->lexpr, time))
 				ct_expr = (A_Expr *) sw_expr->rexpr;
 			else
 				ct_expr = (A_Expr *) sw_expr->lexpr;
 
-			fname = get_truncation_from_interval_expr(ct_expr->rexpr);
-			func->funcname = list_make1(makeString(fname));
+			step = get_step_size_interval_expr(ct_expr->rexpr);
+			func->funcname = list_make1(makeString(DATE_FLOOR));
+			func->args = lappend(func->args, (Node *) step);
 		}
 		else
 			func->funcname = list_make1(makeString(DATE_TRUNC_SECOND));
diff --git a/src/backend/utils/misc/guc.c b/src/backend/utils/misc/guc.c
index 2b739b167..c61f31367 100644
--- a/src/backend/utils/misc/guc.c
+++ b/src/backend/utils/misc/guc.c
@@ -2657,6 +2657,17 @@ static struct config_int ConfigureNamesInt[] =
 		NULL, NULL, NULL
 	},
 
+	{
+		{"sliding_window_step_factor", PGC_BACKEND, QUERY_TUNING_OTHER,
+		 gettext_noop("Sets the fraction of a sliding window's width to wait before updating a sliding-window continuous view."),
+		 gettext_noop("A larger fraction will increase sliding-window query performance at the expense of the continuous view updating less frequently."),
+		 GUC_UNIT_S
+		},
+		&sliding_window_step_factor,
+		5, 1, 100,
+		NULL, NULL, NULL
+	},
+
 	{
 		{"stream_insertion_commit_interval", PGC_BACKEND, QUERY_TUNING_OTHER,
 		 gettext_noop("Sets the default amount of time to periodically commit from a stream insertion process."),
diff --git a/src/include/commands/pipelinecmds.h b/src/include/commands/pipelinecmds.h
index 75c82974d..721dab82e 100644
--- a/src/include/commands/pipelinecmds.h
+++ b/src/include/commands/pipelinecmds.h
@@ -20,6 +20,7 @@
 
 /* guc parameter */
 extern int continuous_view_fillfactor;
+extern int sliding_window_step_factor;
 
 extern void ExecCreateContViewStmt(CreateContViewStmt *stmt, const char *querystring);
 extern void ExecTruncateContViewStmt(TruncateStmt *stmt);
diff --git a/src/test/regress/expected/analyze_cont_view.out b/src/test/regress/expected/analyze_cont_view.out
index 1ae2692b5..66aca3a00 100644
--- a/src/test/regress/expected/analyze_cont_view.out
+++ b/src/test/regress/expected/analyze_cont_view.out
@@ -149,11 +149,7 @@ CREATE CONTINUOUS VIEW cqanalyze37 AS SELECT key::text from stream ORDER BY arri
 ERROR:  continuous queries don't support ORDER BY
 -- Sliding window queries
 CREATE CONTINUOUS VIEW cqanalyze38 AS SELECT COUNT(*) FROM analyze_cont_stream WHERE arrival_timestamp > clock_timestamp() - interval '1 hour';
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW cqanalyze39 AS SELECT COUNT(*) FROM analyze_cont_stream WHERE arrival_timestamp > clock_timestamp() - interval '1 hour' AND key::text='pipelinedb';
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW cqanalyze40 AS SELECT COUNT(*) FROM analyze_cont_stream WHERE NOT arrival_timestamp > clock_timestamp() - interval '1 hour';
 ERROR:  clock_timestamp() may only appear as a top-level conjunction predicate
 LINE 1: ...analyze_cont_stream WHERE NOT arrival_timestamp > clock_time...
@@ -183,11 +179,7 @@ LINE 1: ...ot_created AS SELECT g::integer, dense_rank(2, 3, 4) WITHIN ...
 CREATE CONTINUOUS VIEW cqanalyze47 AS SELECT g::integer, rank(2, 3, 4) WITHIN GROUP (ORDER BY x::integer, y::integer, z::integer), sum(x + y + z) FROM analyze_cont_stream4 GROUP BY g;
 -- Sliding windows
 CREATE CONTINUOUS VIEW cqanalyze48 AS SELECT cume_dist(2) WITHIN GROUP (ORDER BY x::integer DESC) FROM analyze_cont_stream3 WHERE (arrival_timestamp > clock_timestamp() - interval '5 minutes');
-NOTICE:  window width is "5 minutes" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW cqanalyze49 AS SELECT percent_rank(2) WITHIN GROUP (ORDER BY x::integer DESC), rank(2) WITHIN GROUP (ORDER BY x) FROM analyze_cont_stream3 WHERE (arrival_timestamp > clock_timestamp() - interval '5 minutes');
-NOTICE:  window width is "5 minutes" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- Verify that we get an error if we try to create a CV that only selects from tables
 CREATE TABLE cqanalyze_table (id integer);
 CREATE CONTINUOUS VIEW error_not_created AS SELECT cqanalyze_table.id::integer FROM cqanalyze_table;
@@ -218,11 +210,7 @@ LINE 1: ...REATE CONTINUOUS VIEW error_not_created AS SELECT percentile...
 HINT:  No function matches the given name and argument types. You might need to add explicit type casts.
 -- Sliding windows
 CREATE CONTINUOUS VIEW cqanalyze52 AS SELECT g::integer, percentile_cont(ARRAY[0.2, 0.8]) WITHIN GROUP (ORDER BY x::float), percentile_cont(0.9) WITHIN GROUP (ORDER BY y::integer) + percentile_cont(0.1) WITHIN GROUP (ORDER BY z::numeric) AS col FROM analyze_cont_stream6 WHERE (arrival_timestamp > clock_timestamp() - interval '5 minutes') GROUP BY g;
-NOTICE:  window width is "5 minutes" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW cqanalyze53 AS SELECT percentile_cont(0.1) WITHIN GROUP (ORDER BY x::float + y::integer) FROM analyze_cont_stream3 WHERE (arrival_timestamp > clock_timestamp() - interval '5 minutes');
-NOTICE:  window width is "5 minutes" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW funcs AS SELECT floor(x::float8), date_trunc('day', arrival_timestamp), COUNT(*) FROM stream GROUP BY floor, date_trunc;
 DROP CONTINUOUS VIEW cqanalyze0;
 DROP CONTINUOUS VIEW cqanalyze1;
diff --git a/src/test/regress/expected/cont_distinct.out b/src/test/regress/expected/cont_distinct.out
index 49177007b..e0a993fe3 100644
--- a/src/test/regress/expected/cont_distinct.out
+++ b/src/test/regress/expected/cont_distinct.out
@@ -1,11 +1,7 @@
 -- COUNT(DISTINCT ...)
 CREATE CONTINUOUS VIEW test_distinct_count AS SELECT COUNT(DISTINCT x::integer) FROM test_distinct_count_stream;
 CREATE CONTINUOUS VIEW test_distinct_sw_count AS SELECT COUNT(DISTINCT x::integer) FROM test_distinct_count_stream WHERE (arrival_timestamp > clock_timestamp() - interval '10 seconds');
-NOTICE:  window width is "10 seconds" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_distinct_sw_count_small AS SELECT COUNT(DISTINCT x::integer) FROM test_distinct_count_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 second');;
-NOTICE:  window width is "1 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_distinct_count_stream (x, y, z) VALUES (1, 1, '1'), (1, 1, '1'), (4, 4, '4'), (7, 7, '7'), (0, 0, '0'), (2, 2, '2'), (4, 4, '4'), (8, 8, '8'), (8, 8, '8'), (7, 7, '7'), (9, 9, '9'), (6, 6, '6'), (2, 2, '2'), (6, 6, '6'), (5, 5, '5'), (3, 3, '3'), (9, 9, '9'), (0, 0, '0'), (5, 5, '5'), (3, 3, '3');
 INSERT INTO test_distinct_count_stream (z, y, x) VALUES ('1', 1, 1);
 INSERT INTO test_distinct_count_stream (z, y, x) VALUES ('9', 9, 9);
diff --git a/src/test/regress/expected/cont_gis_geom.out b/src/test/regress/expected/cont_gis_geom.out
index 8b6a464e0..cb5746eee 100644
--- a/src/test/regress/expected/cont_gis_geom.out
+++ b/src/test/regress/expected/cont_gis_geom.out
@@ -1,53 +1,33 @@
 -- ST_Extent(geometry)
 CREATE CONTINUOUS VIEW test_st_extent AS SELECT id::integer, ST_Extent(g::geometry) FROM test_gis_geom_stream GROUP BY id;
 CREATE CONTINUOUS VIEW test_sw_st_extent AS SELECT id::integer, ST_Extent(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY id;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_3DExtent(geometry)
 CREATE CONTINUOUS VIEW test_st_3dextent AS SELECT id::integer, ST_3DExtent(g::geometry) FROM test_gis_geom_stream GROUP BY id;
 CREATE CONTINUOUS VIEW test_sw_st_3dextent AS SELECT id::integer, ST_3DExtent(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY id;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_Collect(geometry)
 CREATE CONTINUOUS VIEW test_st_collect AS SELECT ST_Collect(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_collect AS SELECT ST_Collect(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_MemCollect(geometry)
 CREATE CONTINUOUS VIEW test_st_memcollect AS SELECT ST_MemCollect(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_memcollect AS SELECT ST_MemCollect(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_Union(geometry)
 CREATE CONTINUOUS VIEW test_st_union AS SELECT ST_Union(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_union AS SELECT ST_Union(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_MemUnion(geometry)
 CREATE CONTINUOUS VIEW test_st_memunion AS SELECT ST_MemUnion(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_memunion AS SELECT ST_MemUnion(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_Accum(geometry)
 CREATE CONTINUOUS VIEW test_st_accum AS SELECT ST_Accum(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_accum AS SELECT ST_Accum(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_Polygonize(geometry)
 CREATE CONTINUOUS VIEW test_st_polygonize AS SELECT ST_Polygonize(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_polygonize AS SELECT ST_Polygonize(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_MakeLine(geometry)
 CREATE CONTINUOUS VIEW test_st_makeline AS SELECT ST_MakeLine(g::geometry) FROM test_gis_geom_stream;
 CREATE CONTINUOUS VIEW test_sw_st_makeline AS SELECT ST_MakeLine(g::geometry) FROM test_gis_geom_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- topology.TopoElementArray_agg(topology.TopoElement)
 CREATE CONTINUOUS VIEW test_topo_agg AS SELECT id::integer, topology.TopoElementArray_agg(a::topology.TopoElement) FROM test_gis_topo_stream GROUP BY id;
 CREATE CONTINUOUS VIEW test_sw_topo_agg AS SELECT id::integer, topology.TopoElementArray_agg(a::topology.TopoElement) FROM test_gis_topo_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour')  GROUP BY id;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_gis_geom_stream (id, g) VALUES (0, ST_MakePoint(32.38565653, 38.34148459, 1.58807849));
 INSERT INTO test_gis_geom_stream (id, g) VALUES (1, ST_MakePoint(60.13235956, 18.85041258, 7.95839553));
 INSERT INTO test_gis_geom_stream (id, g) VALUES (2, ST_MakePoint(34.28629657, 16.78774138, 2.91220975));
diff --git a/src/test/regress/expected/cont_gis_raster.out b/src/test/regress/expected/cont_gis_raster.out
index 7a5760d35..3efd7e204 100644
--- a/src/test/regress/expected/cont_gis_raster.out
+++ b/src/test/regress/expected/cont_gis_raster.out
@@ -5,14 +5,8 @@ CREATE CONTINUOUS VIEW test_st_stats_agg1 AS SELECT ST_SummaryStatsAgg(r::raster
 CREATE CONTINUOUS VIEW test_st_stats_agg2 AS SELECT ST_SummaryStatsAgg(r::raster, true, 1.0) FROM test_gis_raster_stream;
 CREATE CONTINUOUS VIEW test_st_stats_agg0 AS SELECT ST_SummaryStatsAgg(r::raster, 1, true, 1.0) FROM test_gis_raster_stream ;
 CREATE CONTINUOUS VIEW test_sw_st_stats_agg1 AS SELECT ST_SummaryStatsAgg(r::raster, 1, true) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_stats_agg2 AS SELECT ST_SummaryStatsAgg(r::raster, true, 1.0) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_stats_agg0 AS SELECT ST_SummaryStatsAgg(r::raster, 1, true, 1.0) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_CountAgg(raster, boolean)
 -- ST_CountAgg(raster, integer, boolean)
 -- ST_CountAgg(raster, integer, boolean, double)
@@ -20,19 +14,11 @@ CREATE CONTINUOUS VIEW test_st_countagg0 AS SELECT ST_CountAgg(r::raster, true)
 CREATE CONTINUOUS VIEW test_st_countagg1 AS SELECT ST_CountAgg(r::raster, 1, true) FROM test_gis_raster_stream;
 CREATE CONTINUOUS VIEW test_st_countagg2 AS SELECT ST_CountAgg(r::raster, 1, true, 0.0) FROM test_gis_raster_stream;
 CREATE CONTINUOUS VIEW test_sw_st_countagg0 AS SELECT ST_CountAgg(r::raster, true) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_countagg1 AS SELECT ST_CountAgg(r::raster, 1, true) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_countagg2 AS SELECT ST_CountAgg(r::raster, 1, true, 0.0) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_SameAlignment(raster)
 CREATE CONTINUOUS VIEW test_st_samealignment AS SELECT ST_SameAlignment(r::raster) FROM test_gis_raster_stream;
 CREATE CONTINUOUS VIEW test_sw_st_samealignment AS SELECT ST_SameAlignment(r::raster) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- ST_Union(raster)
 -- ST_Union(raster, integer)
 -- ST_Union(raster, text)
@@ -42,17 +28,9 @@ CREATE CONTINUOUS VIEW test_st_union_raster1 AS SELECT Box3D(ST_Union(r::raster,
 CREATE CONTINUOUS VIEW test_st_union_raster2 AS SELECT Box3D(ST_Union(r::raster, 'COUNT')) FROM test_gis_raster_stream;
 CREATE CONTINUOUS VIEW test_st_union_raster3 AS SELECT Box3D(ST_Union(r::raster, 1, 'SUM')) FROM test_gis_raster_stream;
 CREATE CONTINUOUS VIEW test_sw_st_union_raster0 AS SELECT Box3D(ST_Union(r::raster)) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_union_raster1 AS SELECT Box3D(ST_Union(r::raster, 1)) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_union_raster2 AS SELECT Box3D(ST_Union(r::raster, 'COUNT')) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_st_union_raster3 AS SELECT Box3D(ST_Union(r::raster, 1, 'SUM')) FROM test_gis_raster_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_gis_raster_stream (id, r) VALUES (0, ST_SetValue(ST_AddBand(ST_MakeEmptyRaster(21, 75, 0.000, 0.000, 0.1), '64BF', 0.0, 0.0), 1, 1, 0.502));
 INSERT INTO test_gis_raster_stream (id, r) VALUES (1, ST_SetValue(ST_AddBand(ST_MakeEmptyRaster(93, 58, 0.000, 0.000, 0.1), '64BF', 0.0, 0.0), 1, 1, 0.153));
 INSERT INTO test_gis_raster_stream (id, r) VALUES (2, ST_SetValue(ST_AddBand(ST_MakeEmptyRaster(48, 62, 0.000, 0.000, 0.1), '64BF', 0.0, 0.0), 1, 1, 0.196));
diff --git a/src/test/regress/expected/cont_hll_agg.out b/src/test/regress/expected/cont_hll_agg.out
index 4898f7c69..1ec0a65b3 100644
--- a/src/test/regress/expected/cont_hll_agg.out
+++ b/src/test/regress/expected/cont_hll_agg.out
@@ -2,14 +2,8 @@ CREATE CONTINUOUS VIEW test_hll_agg0 AS SELECT k::text, hll_agg(x::integer) FROM
 CREATE CONTINUOUS VIEW test_hll_agg1 AS SELECT k::text, hll_cardinality(hll_agg(x::integer)) + hll_cardinality(hll_agg(y::text)) FROM test_hll_agg_stream GROUP BY k;
 CREATE CONTINUOUS VIEW test_hll_agg2 AS SELECT k::text, hll_cardinality(hll_agg(x::integer)) + hll_cardinality(hll_agg(substring(y::text, 1, 1))) FROM test_hll_agg_stream GROUP BY k;
 CREATE CONTINUOUS VIEW test_sw_hll_agg0 AS SELECT k::text, hll_print(hll_agg(x::integer)) FROM test_hll_agg_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY k;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_hll_agg1 AS SELECT k::text, hll_cardinality(hll_agg(x::integer)) + hll_cardinality(hll_agg(y::text)) FROM test_hll_agg_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour')  GROUP BY k;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_hll_agg2 AS SELECT k::text, hll_cardinality(hll_agg(x::integer)) + hll_cardinality(hll_agg(substring(y::text, 1, 1))) FROM test_hll_agg_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour')  GROUP BY k;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_hll_agg_stream (k, x, y) VALUES ('0', 0, '0');
 INSERT INTO test_hll_agg_stream (k, x, y) VALUES ('1', 1, '100');
 INSERT INTO test_hll_agg_stream (k, x, y) VALUES ('2', 2, '200');
diff --git a/src/test/regress/expected/cont_sw_avg.out b/src/test/regress/expected/cont_sw_avg.out
index 4e8b0b21a..59a01a6df 100644
--- a/src/test/regress/expected/cont_sw_avg.out
+++ b/src/test/regress/expected/cont_sw_avg.out
@@ -1,14 +1,8 @@
 -------------------------------------------------------------------------------
 -- Integer averages
 CREATE CONTINUOUS VIEW test_int8_avg_sw AS SELECT k::text, AVG(v::int8) FROM int_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_int4_avg_sw AS SELECT k::text, AVG(v::int4) FROM int_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_int2_avg_sw AS SELECT k::text, AVG(v::int2) FROM int_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO int_swavg_stream (k, v) VALUES ('x', 1), ('x', 1), ('x', 1);
 INSERT INTO int_swavg_stream (k, v) VALUES ('y', -10000), ('y', 10000), ('y', 0);
 SELECT * FROM test_int8_avg_sw ORDER BY k;
@@ -64,11 +58,7 @@ SELECT * FROM test_int2_avg_sw ORDER BY k;
 -------------------------------------------------------------------------------
 -- Float averages
 CREATE CONTINUOUS VIEW test_float8_avg_sw AS SELECT k::text, AVG(v::float8) FROM float_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_float4_avg_sw AS SELECT k::text, AVG(v::float4) FROM float_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO float_swavg_stream (k, v) VALUES ('x', 1e6), ('x', -1e6), ('x', 10.0000001);
 INSERT INTO float_swavg_stream (k, v) VALUES ('y', 0.0001), ('y', 0.00002), ('y', 155321233.1);
 SELECT k, round(avg::numeric, 5) FROM test_float8_avg_sw ORDER BY k;
@@ -112,8 +102,6 @@ SELECT k, round(avg::numeric, 5) FROM test_float4_avg_sw ORDER BY k;
 -------------------------------------------------------------------------------
 -- Numeric averages
 CREATE CONTINUOUS VIEW test_numeric_avg_sw AS SELECT k::text, AVG(v::numeric) FROM numeric_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO numeric_swavg_stream (k, v) VALUES ('x', 10000000000000000.233), ('x', -1.000000000333), ('x', 0.00000000001);
 INSERT INTO numeric_swavg_stream (k, v) VALUES ('y', 0.1001), ('y', 0.99999999), ('y', -999999999999999999.999999999999);
 SELECT * FROM test_numeric_avg_sw ORDER BY k;
@@ -141,8 +129,6 @@ SELECT * FROM test_numeric_avg_sw ORDER BY k;
 -------------------------------------------------------------------------------
 -- Interval averages
 CREATE CONTINUOUS VIEW test_interval_avg_sw AS SELECT k::text, AVG(date_trunc('day', ts1::timestamp) - date_trunc('day', ts0::timestamp)) FROM interval_swavg_stream WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO interval_swavg_stream (k, ts0, ts1) VALUES ('x', '2014-01-01 00:00:00', '2014-01-02 23:00:00');
 INSERT INTO interval_swavg_stream (k, ts0, ts1) VALUES ('x', '2014-01-01 00:00:00', '2014-01-02 01:00:00');
 INSERT INTO interval_swavg_stream (k, ts0, ts1) VALUES ('x', '2014-01-01 00:00:00', '2014-01-02 11:00:00');
@@ -172,8 +158,6 @@ CREATE CONTINUOUS VIEW avg_heart_rates AS
 SELECT patient_id::integer, avg(value::float) FROM heart_rates_stream
 WHERE description::text = 'HR' AND value > 85
 AND (arrival_timestamp > clock_timestamp() - interval '5 minutes') GROUP BY patient_id;
-NOTICE:  window width is "5 minutes" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO heart_rates_stream (patient_id, value, description) VALUES (0, 86, 'HR');
 INSERT INTO heart_rates_stream (patient_id, value, description) VALUES (0, 87, 'HR');
 INSERT INTO heart_rates_stream (patient_id, value, description) VALUES (0, 85, 'HR');
diff --git a/src/test/regress/expected/cont_sw_bool_agg.out b/src/test/regress/expected/cont_sw_bool_agg.out
index c4ce29225..0536062cf 100644
--- a/src/test/regress/expected/cont_sw_bool_agg.out
+++ b/src/test/regress/expected/cont_sw_bool_agg.out
@@ -1,8 +1,6 @@
 -- bit_and, bit_or
 CREATE CONTINUOUS VIEW test_sw_bit_and AS SELECT k::text, bit_and(b::bit) FROM bit_test_sw_sw_stream GROUP BY k;
 CREATE CONTINUOUS VIEW test_sw_bit_or AS SELECT k::text, bit_or(b::bit) FROM bit_test_sw_sw_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second'  GROUP BY k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO bit_test_sw_sw_stream (k, b) VALUES ('x', 1::bit), ('x', '1'::bit), ('x', 1::bit), ('x', 1::bit), ('x', 1::bit), ('x', 1::bit), ('x', 1::bit);
 INSERT INTO bit_test_sw_sw_stream (k, b) VALUES ('y', 0::bit), ('y', 1::bit), ('y', 0::bit), ('x', 1::bit), ('x', 1::bit), ('x', 1::bit), ('x', 1::bit);
 SELECT * FROM test_sw_bit_and ORDER BY k DESC;
@@ -43,14 +41,8 @@ SELECT * FROM test_sw_bit_or ORDER BY k DESC;
 
 -- bool_and, bool_or, every
 CREATE CONTINUOUS VIEW test_sw_bool_and AS SELECT k::text, bool_and(b::boolean) FROM bool_test_sw_sw_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second'  GROUP BY k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_bool_or AS SELECT k::text, bool_or(b::boolean) FROM bool_test_sw_sw_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second'  GROUP BY k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_every AS SELECT k::text, every(b::boolean) FROM bool_test_sw_sw_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second'  GROUP BY k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO bool_test_sw_sw_stream (k, b) VALUES ('x', 't'), ('x', 't'), ('x', true), ('x', 't'), ('x', 't'), ('x', true), ('x', true);
 INSERT INTO bool_test_sw_sw_stream (k, b) VALUES ('y', false), ('y', 'f'), ('y', 'f'), ('x', false), ('x', true), ('x', true), ('x', 't');
 SELECT * FROM test_sw_bool_and ORDER BY k DESC;
diff --git a/src/test/regress/expected/cont_sw_count.out b/src/test/regress/expected/cont_sw_count.out
index bf8069338..5b50f2c3e 100644
--- a/src/test/regress/expected/cont_sw_count.out
+++ b/src/test/regress/expected/cont_sw_count.out
@@ -1,6 +1,4 @@
 CREATE CONTINUOUS VIEW test_count AS SELECT k::text, COUNT(*) FROM cqswcount_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP BY k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cqswcount_stream (k) VALUES ('x'), ('x'), ('x'), ('x'), ('x'), ('x');
 INSERT INTO cqswcount_stream (k) VALUES ('x'), ('x'), ('x'), ('x'), ('x'), ('x'), ('y'), ('y'), ('y'), ('y'), ('y'), ('y');
 SELECT * FROM test_count ORDER BY k;
@@ -27,8 +25,6 @@ SELECT * FROM test_count ORDER BY k;
 
 DROP CONTINUOUS VIEW test_count;
 CREATE CONTINUOUS VIEW sw_count0 AS SELECT COUNT(*) FROM cqswcount_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE VIEW sw_count1 AS SELECT combine(count) FROM sw_count0_mrel0 WHERE arrival_timestamp > clock_timestamp() - interval '2 second';
 INSERT INTO cqswcount_stream (k) VALUES ('x'), ('x');
 SELECT * FROM sw_count0;
diff --git a/src/test/regress/expected/cont_sw_hs_agg.out b/src/test/regress/expected/cont_sw_hs_agg.out
index 8e3fd4439..2b9da2c23 100644
--- a/src/test/regress/expected/cont_sw_hs_agg.out
+++ b/src/test/regress/expected/cont_sw_hs_agg.out
@@ -1,53 +1,23 @@
 -- First use big windows to verify that we get the same results as identical queries without sliding windows
 -- rank
 CREATE CONTINUOUS VIEW test_sw_rank0 AS SELECT rank(7, 47, '47') WITHIN GROUP (ORDER BY x::integer, y::integer, z::text) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_rank1 AS SELECT g::integer, rank(5, 5) WITHIN GROUP (ORDER BY g, x::integer) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY g;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_rank2 AS SELECT g::integer, rank(-10, 10) WITHIN GROUP (ORDER BY g, x::integer DESC) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY g;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_rank3 AS SELECT g::integer, rank(2, 1000, 1000, '1000') WITHIN GROUP (ORDER BY g, x::integer, y::integer, z::text) + rank(1000000) WITHIN GROUP (ORDER BY x) AS rank_sum FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY g;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- percent_rank
 CREATE CONTINUOUS VIEW test_sw_percent0 AS SELECT percent_rank(2) WITHIN GROUP (ORDER BY x::integer) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_percent1 AS SELECT g::integer, percent_rank('7') WITHIN GROUP (ORDER BY z::text) AS p0, percent_rank('00') WITHIN GROUP (ORDER BY z) AS p1 FROM test_sw_hs_stream  WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY g;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_percent2 AS SELECT percent_rank(27, -27, '27') WITHIN GROUP (ORDER BY x::integer, y::integer, z::text) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_percent3 AS SELECT percent_rank(10.1, 10.2) WITHIN GROUP (ORDER BY x::float8, y::float8) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- cume_dist
 CREATE CONTINUOUS VIEW test_sw_cume_dist0 AS SELECT cume_dist(-2 * 6) WITHIN GROUP (ORDER BY x::integer DESC) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_cume_dist1 AS SELECT g::integer, cume_dist(10, -10) WITHIN GROUP (ORDER BY g, x::integer) AS c0, cume_dist(2, -2) WITHIN GROUP (ORDER BY g, x) AS c1 FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour') GROUP BY g;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_cume_dist2 AS SELECT cume_dist(50, -50, '50') WITHIN GROUP (ORDER BY x::integer, y::integer, z::text) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_cume_dist3 AS SELECT cume_dist(10.1, 10.2) WITHIN GROUP (ORDER BY x::float8, y::float8) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- dense_rank
 CREATE CONTINUOUS VIEW test_sw_dense_rank0 AS SELECT dense_rank(10) WITHIN GROUP (ORDER BY x::integer), rank(10) WITHIN GROUP (ORDER BY x) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_dense_rank1 AS SELECT dense_rank(substring('30', 1, 2)) WITHIN GROUP (ORDER BY z::text) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_dense_rank2 AS SELECT dense_rank(30, -30, '30') WITHIN GROUP (ORDER BY x::integer, y::integer, z::text), rank(30, -30, '30') WITHIN GROUP (ORDER BY x::integer, y::integer, z::text) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '1 hour');
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_sw_hs_stream (g, x, y, z) VALUES (7, 27, -27, '27'), (2, 32, -32, '32'), (4, 4, -4, '4'), (6, 26, -26, '26'), (1, 11, -11, '11'), (0, 60, -60, '60'), (2, 82, -82, '82'), (0, 40, -40, '40'), (9, 19, -19, '19'), (7, 77, -77, '77'), (8, 18, -18, '18'), (9, 99, -99, '99'), (5, 85, -85, '85'), (8, 98, -98, '98'), (7, 57, -57, '57'), (5, 65, -65, '65'), (3, 43, -43, '43'), (0, 0, 0, '0'), (8, 38, -38, '38'), (6, 36, -36, '36'), (3, 83, -83, '83'), (7, 97, -97, '97'), (6, 86, -86, '86'), (9, 29, -29, '29'), (9, 79, -79, '79'), (4, 24, -24, '24'), (6, 46, -46, '46'), (1, 51, -51, '51'), (5, 45, -45, '45'), (0, 30, -30, '30'), (1, 61, -61, '61'), (7, 87, -87, '87'), (5, 5, -5, '5'), (4, 54, -54, '54'), (2, 22, -22, '22'), (5, 55, -55, '55'), (3, 13, -13, '13'), (2, 2, -2, '2'), (8, 58, -58, '58'), (2, 72, -72, '72'), (8, 48, -48, '48'), (4, 74, -74, '74'), (6, 16, -16, '16'), (9, 39, -39, '39'), (3, 53, -53, '53'), (8, 78, -78, '78'), (8, 88, -88, '88'), (3, 93, -93, '93'), (0, 50, -50, '50'), (1, 21, -21, '21'), (4, 34, -34, '34'), (1, 71, -71, '71'), (9, 49, -49, '49'), (7, 47, -47, '47'), (6, 56, -56, '56'), (6, 76, -76, '76'), (3, 73, -73, '73'), (0, 10, -10, '10'), (8, 28, -28, '28'), (2, 52, -52, '52'), (8, 8, -8, '8'), (3, 33, -33, '33'), (1, 41, -41, '41'), (0, 90, -90, '90'), (4, 94, -94, '94'), (4, 64, -64, '64'), (3, 23, -23, '23'), (0, 20, -20, '20'), (9, 69, -69, '69'), (6, 66, -66, '66'), (5, 95, -95, '95'), (6, 6, -6, '6'), (7, 37, -37, '37'), (5, 15, -15, '15'), (4, 84, -84, '84'), (3, 63, -63, '63'), (1, 31, -31, '31'), (2, 62, -62, '62'), (0, 80, -80, '80'), (5, 25, -25, '25'), (3, 3, -3, '3'), (9, 89, -89, '89'), (2, 42, -42, '42'), (8, 68, -68, '68'), (2, 12, -12, '12'), (1, 81, -81, '81'), (4, 14, -14, '14'), (0, 70, -70, '70'), (7, 67, -67, '67'), (2, 92, -92, '92'), (5, 75, -75, '75'), (7, 17, -17, '17'), (7, 7, -7, '7'), (1, 91, -91, '91'), (5, 35, -35, '35'), (9, 59, -59, '59'), (9, 9, -9, '9'), (1, 1, -1, '1'), (6, 96, -96, '96'), (4, 44, -44, '44');
 INSERT INTO test_sw_hs_stream (g, x, y, z) VALUES (5, 5, -5, '5');
 INSERT INTO test_sw_hs_stream (g, x, y, z) VALUES (5, 15, -15, '15');
@@ -210,8 +180,6 @@ rank(5, -5) WITHIN GROUP (ORDER BY x::integer, y::integer),
 dense_rank(5, -5) WITHIN GROUP (ORDER BY x, y),
 percent_rank(10, -10) WITHIN GROUP (ORDER BY x, y),
 cume_dist(15, -15) WITHIN GROUP (ORDER BY x, y) FROM test_sw_hs_stream WHERE (arrival_timestamp > clock_timestamp() - interval '60 second');
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_sw_hs_stream (g, x, y, z) VALUES (0, 0, 0, '0');
 INSERT INTO test_sw_hs_stream (g, x, y, z) VALUES (1, 1, -1, '1');
 INSERT INTO test_sw_hs_stream (g, x, y, z) VALUES (2, 2, -2, '2');
diff --git a/src/test/regress/expected/cont_sw_min_max.out b/src/test/regress/expected/cont_sw_min_max.out
index c653bcc7b..8975f27f1 100644
--- a/src/test/regress/expected/cont_sw_min_max.out
+++ b/src/test/regress/expected/cont_sw_min_max.out
@@ -17,8 +17,6 @@ min(txt::text) AS txtmin, max(txt) AS txtmax,
 min(n::numeric) AS nmin, max(n) AS nmax,
 min(a::int[]) AS amin, max(a) AS amax
 FROM sw_minmax_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP BY key;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO sw_minmax_stream
 (key, i8, i4, i2, o, f8, f4, d, t, tz, m, ts, tstz, ts1, ts0, txt, n, a) VALUES
 ('x', 0, 1, 2, 443, 42.33, 80003.00001, '2014-12-31', '2014-02-28 00:00:00', '2014-02-28 00:00:00-08', 999023.39, '2014-01-01 00:00:00', '2014-01-01 00:00:01-08', '2014-01-01 00:00:00', '2014-01-02 00:00:00', 'first row', -0.00000000042, '{-1, 0, 1}');
diff --git a/src/test/regress/expected/cont_sw_object_agg.out b/src/test/regress/expected/cont_sw_object_agg.out
index 732c440d5..e820105f2 100644
--- a/src/test/regress/expected/cont_sw_object_agg.out
+++ b/src/test/regress/expected/cont_sw_object_agg.out
@@ -75,8 +75,6 @@ CREATE FUNCTION
 LANGUAGE plpgsql;
 -- json_agg
 CREATE CONTINUOUS VIEW test_sw_json_agg AS SELECT key::text, json_agg(tval::text) AS j0, json_agg(fval::float8) AS j1, json_agg(ival::integer) AS j2 FROM cqswobjectagg_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP BY key;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cqswobjectagg_stream (key, tval, fval, ival) VALUES ('x', 'text', 0.01, 41), ('x', 'more text', 0.02, 42), ('x', 'blaahhhh', 0.03, 43);
 INSERT INTO cqswobjectagg_stream (key, tval, fval, ival) VALUES ('y', '4.2', 1.01, 42), ('z', '\"quoted\"', 2.01, 42), ('x', '', 0.04, 44), ('z', '2', '3', '4');
 SELECT key, array_sort(json_to_array(j0)) FROM test_sw_json_agg ORDER BY key;
@@ -137,11 +135,7 @@ SELECT key, array_sort(json_to_array(j2)) FROM test_sw_json_agg ORDER BY key;
 DROP CONTINUOUS VIEW test_sw_json_agg;
 -- json_object_agg
 CREATE CONTINUOUS VIEW test_sw_object_agg0 AS SELECT n, json_object_agg(n::text, v::integer) FROM cqswobjectagg_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP BY n;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_object_agg1 AS SELECT n, json_object_agg(n::text, t::text) FROM cqswobjectagg_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP BY n;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cqswobjectagg_stream (n, v, t) VALUES ('k0', 1, '1');
 INSERT INTO cqswobjectagg_stream (n, v, t) VALUES ('k0', 2, '2');
 INSERT INTO cqswobjectagg_stream (n, v, t) VALUES ('k1', 3, '3');
@@ -196,11 +190,7 @@ DROP CONTINUOUS VIEW test_sw_object_agg0;
 DROP CONTINUOUS VIEW test_sw_object_agg1;
 -- bytea_string_agg, string_agg
 CREATE CONTINUOUS VIEW test_sw_bstring_agg AS SELECT k::text, string_agg(v::bytea, '@') FROM cqswobjectagg_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP by k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_string_agg AS SELECT k::text, string_agg(v::text, '@') FROM cqswobjectagg_text_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP by k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cqswobjectagg_stream (k, v) VALUES ('x', 'val0'), ('x', 'val1');
 INSERT INTO cqswobjectagg_stream (k, v) VALUES ('y', 'val0'), ('y', 'val1');
 INSERT INTO cqswobjectagg_text_stream (k, v) VALUES ('x', 'val0'), ('x', 'val1');
@@ -249,8 +239,6 @@ DROP CONTINUOUS VIEW test_sw_bstring_agg;
 DROP CONTINUOUS VIEW test_sw_string_agg;
 -- array_agg
 CREATE CONTINUOUS VIEW test_sw_array_agg AS SELECT k::text, array_agg(v::integer) FROM cqswobjectagg_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second' GROUP BY k;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cqswobjectagg_stream (k, v) VALUES ('x', 0), ('x', 1), ('x', 2), ('x', 3);
 INSERT INTO cqswobjectagg_stream (k, v) VALUES ('y', 0), ('y', 1);
 SELECT k, array_sort(array_agg) FROM test_sw_array_agg ORDER BY k;
diff --git a/src/test/regress/expected/cont_sw_os_agg.out b/src/test/regress/expected/cont_sw_os_agg.out
index 285b39f5e..41b09222e 100644
--- a/src/test/regress/expected/cont_sw_os_agg.out
+++ b/src/test/regress/expected/cont_sw_os_agg.out
@@ -1,13 +1,7 @@
 -- percentile_cont
 CREATE CONTINUOUS VIEW test_sw_pc0 AS SELECT percentile_cont(0.23) WITHIN GROUP (ORDER BY x::integer) FROM test_sw_os_stream WHERE (arrival_timestamp > clock_timestamp() - interval '60 second');
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_pc1 AS SELECT g::integer, percentile_cont(ARRAY[0, 0.2, 0.4, 0.6, 0.8, 1.0]) WITHIN GROUP (ORDER BY x::integer - y::integer) FROM test_sw_os_stream WHERE (arrival_timestamp > clock_timestamp() - interval '60 second') GROUP BY g;
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_pc2 AS SELECT percentile_cont(0.67) WITHIN GROUP (ORDER BY x::integer) + percentile_cont(0.88) WITHIN GROUP (ORDER BY z::integer) FROM test_sw_os_stream WHERE (arrival_timestamp > clock_timestamp() - interval '60 second');
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_sw_os_stream (g, x, y, z) VALUES (7, 27, -27, '27'), (2, 32, -32, '32'), (4, 4, -4, '4'), (6, 26, -26, '26'), (1, 11, -11, '11'), (0, 60, -60, '60'), (2, 82, -82, '82'), (0, 40, -40, '40'), (9, 19, -19, '19'), (7, 77, -77, '77'), (8, 18, -18, '18'), (9, 99, -99, '99'), (5, 85, -85, '85'), (8, 98, -98, '98'), (7, 57, -57, '57'), (5, 65, -65, '65'), (3, 43, -43, '43'), (0, 0, 0, '0'), (8, 38, -38, '38'), (6, 36, -36, '36'), (3, 83, -83, '83'), (7, 97, -97, '97'), (6, 86, -86, '86'), (9, 29, -29, '29'), (9, 79, -79, '79'), (4, 24, -24, '24'), (6, 46, -46, '46'), (1, 51, -51, '51'), (5, 45, -45, '45'), (0, 30, -30, '30'), (1, 61, -61, '61'), (7, 87, -87, '87'), (5, 5, -5, '5'), (4, 54, -54, '54'), (2, 22, -22, '22'), (5, 55, -55, '55'), (3, 13, -13, '13'), (2, 2, -2, '2'), (8, 58, -58, '58'), (2, 72, -72, '72'), (8, 48, -48, '48'), (4, 74, -74, '74'), (6, 16, -16, '16'), (9, 39, -39, '39'), (3, 53, -53, '53'), (8, 78, -78, '78'), (8, 88, -88, '88'), (3, 93, -93, '93'), (0, 50, -50, '50'), (1, 21, -21, '21'), (4, 34, -34, '34'), (1, 71, -71, '71'), (9, 49, -49, '49'), (7, 47, -47, '47'), (6, 56, -56, '56'), (6, 76, -76, '76'), (3, 73, -73, '73'), (0, 10, -10, '10'), (8, 28, -28, '28'), (2, 52, -52, '52'), (8, 8, -8, '8'), (3, 33, -33, '33'), (1, 41, -41, '41'), (0, 90, -90, '90'), (4, 94, -94, '94'), (4, 64, -64, '64'), (3, 23, -23, '23'), (0, 20, -20, '20'), (9, 69, -69, '69'), (6, 66, -66, '66'), (5, 95, -95, '95'), (6, 6, -6, '6'), (7, 37, -37, '37'), (5, 15, -15, '15'), (4, 84, -84, '84'), (3, 63, -63, '63'), (1, 31, -31, '31'), (2, 62, -62, '62'), (0, 80, -80, '80'), (5, 25, -25, '25'), (3, 3, -3, '3'), (9, 89, -89, '89'), (2, 42, -42, '42'), (8, 68, -68, '68'), (2, 12, -12, '12'), (1, 81, -81, '81'), (4, 14, -14, '14'), (0, 70, -70, '70'), (7, 67, -67, '67'), (2, 92, -92, '92'), (5, 75, -75, '75'), (7, 17, -17, '17'), (7, 7, -7, '7'), (1, 91, -91, '91'), (5, 35, -35, '35'), (9, 59, -59, '59'), (9, 9, -9, '9'), (1, 1, -1, '1'), (6, 96, -96, '96'), (4, 44, -44, '44');
 SELECT pg_sleep(1);
  pg_sleep 
diff --git a/src/test/regress/expected/cont_sw_regr.out b/src/test/regress/expected/cont_sw_regr.out
index f7d4c4a77..26e7dd651 100644
--- a/src/test/regress/expected/cont_sw_regr.out
+++ b/src/test/regress/expected/cont_sw_regr.out
@@ -1,47 +1,25 @@
 -- regr_sxx
 CREATE CONTINUOUS VIEW test_sw_regr_sxx AS SELECT regr_sxx(x::float8, y::float8) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_syy
 CREATE CONTINUOUS VIEW test_sw_regr_syy AS SELECT regr_syy(x::integer, y::integer) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_sxy
 CREATE CONTINUOUS VIEW test_sw_regr_sxy AS SELECT regr_sxy(x::float4, y::float4) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_avgx
 CREATE CONTINUOUS VIEW test_sw_regr_avgx AS SELECT regr_avgx(x::numeric, y::numeric) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_avgy
 CREATE CONTINUOUS VIEW test_sw_regr_avgy AS SELECT regr_avgy(x::integer, y::integer) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_r2
 CREATE CONTINUOUS VIEW test_sw_regr_r2 AS SELECT regr_r2(x::integer, y::integer) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_slope
 CREATE CONTINUOUS VIEW test_sw_regr_slope AS SELECT regr_slope(x::float8, y::float8) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_intercept
 CREATE CONTINUOUS VIEW test_sw_regr_intercept AS SELECT regr_intercept(x::integer, y::integer) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- regr_count
 CREATE CONTINUOUS VIEW test_sw_regr_count AS SELECT regr_count(x::integer, y::float4) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- covar_pop
 CREATE CONTINUOUS VIEW test_sw_covar_pop AS SELECT covar_pop(x::float4, y::int4) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- corr
 CREATE CONTINUOUS VIEW test_sw_corr AS SELECT corr(x::float4, y::int4) FROM test_sw_regr_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_sw_regr_stream (x, y) VALUES (0, 164), (1, 155), (2, 252), (3, 169), (4, 148), (5, 25), (6, 119), (7, 149), (8, 30), (9, 177), (10, 144), (11, 87), (12, 119), (13, 65), (14, 94), (15, 67), (16, 20), (17, 14), (18, 42), (19, 38), (20, 114), (21, 192), (22, 134), (23, 172), (24, 8), (25, 50), (26, 34), (27, 5), (28, 206), (29, 182), (30, 43), (31, 133), (32, 39), (33, 244), (34, 7), (35, 198), (36, 77), (37, 237), (38, 126), (39, 64), (40, 132), (41, 36), (42, 32), (43, 167), (44, 108), (45, 107), (46, 223), (47, 57), (48, 224), (49, 34), (50, 174), (51, 17), (52, 161), (53, 66), (54, 199), (55, 238), (56, 157), (57, 243), (58, 145), (59, 181), (60, 179), (61, 180), (62, 184), (63, 31), (64, 249), (65, 219), (66, 115), (67, 68), (68, 205), (69, 168), (70, 232), (71, 36), (72, 49), (73, 89), (74, 218), (75, 140), (76, 100), (77, 69), (78, 218), (79, 78), (80, 83), (81, 63), (82, 245), (83, 21), (84, 136), (85, 46), (86, 200), (87, 132), (88, 109), (89, 47), (90, 164), (91, 174), (92, 206), (93, 52), (94, 73), (95, 228), (96, 105), (97, 89), (98, 200), (99, 32);
 SELECT pg_sleep(1);
  pg_sleep 
diff --git a/src/test/regress/expected/cont_sw_stats.out b/src/test/regress/expected/cont_sw_stats.out
index b3e37c89a..dd0bf6051 100644
--- a/src/test/regress/expected/cont_sw_stats.out
+++ b/src/test/regress/expected/cont_sw_stats.out
@@ -3,83 +3,35 @@
 -- variance is the old form of var_samp, but we want to make
 -- sure we support both so we test both forms here.
 CREATE CONTINUOUS VIEW test_sw_stats_int8_var_samp AS SELECT var_samp(x::int8), variance(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int4_var_samp AS SELECT var_samp(x::int4), variance(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int2_var_samp AS SELECT var_samp(x::int2), variance(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_numeric_var_samp AS SELECT var_samp(x::numeric), variance(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float8_var_samp AS SELECT var_samp(x::float8), variance(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float4_var_samp AS SELECT var_samp(x::float4), variance(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- population variance
 CREATE CONTINUOUS VIEW test_sw_stats_int8_var_pop AS SELECT var_pop(x::int8) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int4_var_pop AS SELECT var_pop(x::int4) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int2_var_pop AS SELECT var_pop(x::int2) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_numeric_var_pop AS SELECT var_pop(x::numeric) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float8_var_pop AS SELECT var_pop(x::float8) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float4_var_pop AS SELECT var_pop(x::float4) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- standard deviation
 -- Note: stddev and stddev_samp are the same thing.
 -- stddev is the old form of stddev_samp, but we want to make
 -- sure we support both so we test both forms here.
 CREATE CONTINUOUS VIEW test_sw_stats_int8_stddev_samp AS SELECT stddev_samp(x::int8), stddev(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int4_stddev_samp AS SELECT stddev_samp(x::int4), stddev(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int2_stddev_samp AS SELECT stddev_samp(x::int2), stddev(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_numeric_stddev_samp AS SELECT stddev_samp(x::numeric), stddev(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float8_stddev_samp AS SELECT stddev_samp(x::float8), stddev(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float4_stddev_samp AS SELECT stddev_samp(x::float4), stddev(x) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 -- population standard deviation
 CREATE CONTINUOUS VIEW test_sw_stats_int8_stddev_pop AS SELECT stddev_pop(x::int8) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int4_stddev_pop AS SELECT stddev_pop(x::int4) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_int2_stddev_pop AS SELECT stddev_pop(x::int2) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_numeric_stddev_pop AS SELECT stddev_pop(x::numeric) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float8_stddev_pop AS SELECT stddev_pop(x::float8) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_stats_float4_stddev_pop AS SELECT stddev_pop(x::float4) FROM sw_stats_stream WHERE arrival_timestamp > clock_timestamp() - interval '60 second';
-NOTICE:  window width is "60 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO sw_stats_stream (x) VALUES (665), (982), (976), (274), (621), (83), (959), (178), (83), (680), (529), (554), (311), (222), (217), (883), (359), (973), (6), (859), (729), (415), (431), (369), (684), (464), (607), (567), (852), (945), (11), (178), (703), (709), (493), (352), (371), (432), (933), (361), (765), (210), (16), (590), (432), (263), (665), (315), (150), (556), (309), (233), (259), (826), (301), (529), (117), (27), (337), (84), (638), (64), (82), (347), (326), (189), (880), (4), (365), (608), (1000), (592), (945), (90), (444), (812), (71), (231), (999), (631), (500), (752), (664), (297), (507), (321), (881), (725), (211), (16), (285), (934), (602), (329), (93), (793), (912), (511), (408), (736);
 SELECT pg_sleep(1);
  pg_sleep 
diff --git a/src/test/regress/expected/cont_sw_sum.out b/src/test/regress/expected/cont_sw_sum.out
index 29cb82dc7..ebb40f69f 100644
--- a/src/test/regress/expected/cont_sw_sum.out
+++ b/src/test/regress/expected/cont_sw_sum.out
@@ -1,14 +1,8 @@
 -------------------------------------------------------------------------------
 -- Integer sums
 CREATE CONTINUOUS VIEW test_sw_int8_sum AS SELECT k::text, SUM(v::int8) FROM int_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_int4_sum AS SELECT k::text, SUM(v::int4) FROM int_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_int2_sum AS SELECT k::text, SUM(v::int2) FROM int_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO int_stream_cqswsum (k, v) VALUES ('x', 10), ('x', 10), ('x', 10);
 INSERT INTO int_stream_cqswsum (k, v) VALUES ('y', 10), ('y', 10), ('y', 10);
 SELECT * FROM test_sw_int8_sum ORDER BY k;
@@ -67,11 +61,7 @@ SELECT * FROM test_sw_int2_sum ORDER BY k;
 -------------------------------------------------------------------------------
 -- Float sums
 CREATE CONTINUOUS VIEW test_sw_float8_sum AS SELECT k::text, SUM(v::float8) FROM float_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW test_sw_float4_sum AS SELECT k::text, SUM(v::float4) FROM float_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO float_stream_cqswsum (k, v) VALUES ('x', 10.2), ('x', 1.2), ('x', 0.000001);
 INSERT INTO float_stream_cqswsum (k, v) VALUES ('y', -10.3), ('y', 1.2e6), ('y', '100.4');
 SELECT * FROM test_sw_float8_sum ORDER BY k;
@@ -113,8 +103,6 @@ SELECT * FROM test_sw_float4_sum ORDER BY k;
 -------------------------------------------------------------------------------
 -- Cash sums
 CREATE CONTINUOUS VIEW test_sw_cash_sum AS SELECT k::text, SUM(v::money) FROM cash_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cash_stream_cqswsum (k, v) VALUES ('x', 10.2), ('x', 1.2), ('x', 0.10);
 INSERT INTO cash_stream_cqswsum (k, v) VALUES ('y', -10), ('y', 10), ('y', 0);
 SELECT * FROM test_sw_cash_sum ORDER BY k;
@@ -142,8 +130,6 @@ SELECT * FROM test_sw_cash_sum ORDER BY k;
 -------------------------------------------------------------------------------
 -- Numeric sums
 CREATE CONTINUOUS VIEW test_sw_numeric_sum AS SELECT k::text, SUM(v::numeric) FROM numeric_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO numeric_stream_cqswsum (k, v) VALUES ('x', 10.0002), ('x', 0.0001), ('x', -0.10);
 INSERT INTO numeric_stream_cqswsum (k, v) VALUES ('y', 1.004e5), ('y', 0.4), ('y', 0);
 SELECT * FROM test_sw_numeric_sum ORDER BY k;
@@ -171,8 +157,6 @@ SELECT * FROM test_sw_numeric_sum ORDER BY k;
 -------------------------------------------------------------------------------
 -- Interval sum
 CREATE CONTINUOUS VIEW test_sw_interval_sum AS SELECT k::text, SUM(ts1::timestamp - ts0::timestamp) FROM interval_stream_cqswsum WHERE arrival_timestamp > clock_timestamp() - interval '5 hour' GROUP BY k;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO interval_stream_cqswsum (k, ts0, ts1) VALUES ('x', '2014-01-01', '2014-01-02'), ('x', '2014-01-01', '2014-02-01');
 INSERT INTO interval_stream_cqswsum (k, ts0, ts1) VALUES ('x', '2014-01-01', '2014-01-02'), ('x', '2014-01-01', '2014-02-01');
 SELECT * FROM test_sw_interval_sum ORDER BY k;
diff --git a/src/test/regress/expected/create_cont_view.out b/src/test/regress/expected/create_cont_view.out
index cff22b3c8..c082b6085 100644
--- a/src/test/regress/expected/create_cont_view.out
+++ b/src/test/regress/expected/create_cont_view.out
@@ -181,8 +181,6 @@ SELECT pipeline_get_overlay_viewdef('cqcreate4');
 
 -- Sliding window queries
 CREATE CONTINUOUS VIEW cqcreate5 AS SELECT key::text FROM cont_create_stream2 WHERE arrival_timestamp > (clock_timestamp() - interval '5' second);
-NOTICE:  window width is "5" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 SELECT COUNT(*) FROM pipeline_query WHERE name = 'cqcreate5';
  count 
 -------
@@ -203,7 +201,7 @@ SELECT gc FROM pipeline_query WHERE name = 'cqcreate5';
 View definition:
  SELECT key::text
    FROM ONLY cont_create_stream2
-  WHERE arrival_timestamp::timestamp with time zone > (clock_timestamp() - '@ 5 secs'::interval second);
+  WHERE arrival_timestamp::timestamp with time zone > (clock_timestamp() - '00:00:05'::interval second);
 
 \d+ cqcreate5_mrel0;
                               Table "public.cqcreate5_mrel0"
@@ -220,12 +218,10 @@ SELECT pipeline_get_overlay_viewdef('cqcreate5');
 -----------------------------------------------------------------------------------
   SELECT cqcreate5_mrel0.key                                                      +
     FROM cqcreate5_mrel0                                                          +
-   WHERE (cqcreate5_mrel0._0 > (clock_timestamp() - '@ 5 secs'::interval second));
+   WHERE (cqcreate5_mrel0._0 > (clock_timestamp() - '00:00:05'::interval second));
 (1 row)
 
 CREATE CONTINUOUS VIEW cqcreate6 AS SELECT COUNT(*) FROM cont_create_stream2 WHERE arrival_timestamp > (clock_timestamp() - interval '5' second) GROUP BY key::text;
-NOTICE:  window width is "5" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 SELECT COUNT(*) FROM pipeline_query WHERE name = 'cqcreate6';
  count 
 -------
@@ -246,7 +242,7 @@ SELECT gc FROM pipeline_query WHERE name = 'cqcreate6';
 View definition:
  SELECT count(*) AS count
    FROM ONLY cont_create_stream2
-  WHERE arrival_timestamp::timestamp with time zone > (clock_timestamp() - '@ 5 secs'::interval second)
+  WHERE arrival_timestamp::timestamp with time zone > (clock_timestamp() - '00:00:05'::interval second)
   GROUP BY key::text;
 
 \d+ cqcreate6_mrel0;
@@ -265,7 +261,7 @@ SELECT pipeline_get_overlay_viewdef('cqcreate6');
 -------------------------------------------------------------------------------------------------
   SELECT combine(cqcreate6_mrel0.count) AS count                                                +
     FROM cqcreate6_mrel0                                                                        +
-   WHERE (cqcreate6_mrel0.arrival_timestamp > (clock_timestamp() - '@ 5 secs'::interval second))+
+   WHERE (cqcreate6_mrel0.arrival_timestamp > (clock_timestamp() - '00:00:05'::interval second))+
    GROUP BY cqcreate6_mrel0._1;
 (1 row)
 
@@ -496,8 +492,6 @@ SELECT pipeline_get_overlay_viewdef('cqaggexpr2');
 (1 row)
 
 CREATE CONTINUOUS VIEW cqaggexpr3 AS SELECT key::text, COUNT(*) AS value FROM cont_create_stream2 WHERE arrival_timestamp > (clock_timestamp() - interval '5' second) GROUP BY key;
-NOTICE:  window width is "5" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 \d+ cqaggexpr3;
                View "public.cqaggexpr3"
  Column |  Type   | Modifiers | Storage  | Description 
@@ -508,7 +502,7 @@ View definition:
  SELECT key::text,
     count(*) AS value
    FROM ONLY cont_create_stream2
-  WHERE arrival_timestamp::timestamp with time zone > (clock_timestamp() - '@ 5 secs'::interval second)
+  WHERE arrival_timestamp::timestamp with time zone > (clock_timestamp() - '00:00:05'::interval second)
   GROUP BY key::text;
 
 \d+ cqaggexpr3_mrel0;
@@ -528,7 +522,7 @@ SELECT pipeline_get_overlay_viewdef('cqaggexpr3');
   SELECT cqaggexpr3_mrel0.key,                                                                   +
      combine(cqaggexpr3_mrel0.value) AS value                                                    +
     FROM cqaggexpr3_mrel0                                                                        +
-   WHERE (cqaggexpr3_mrel0.arrival_timestamp > (clock_timestamp() - '@ 5 secs'::interval second))+
+   WHERE (cqaggexpr3_mrel0.arrival_timestamp > (clock_timestamp() - '00:00:05'::interval second))+
    GROUP BY cqaggexpr3_mrel0.key;
 (1 row)
 
@@ -672,6 +666,38 @@ CREATE CONTINUOUS VIEW noss AS SELECT y::integer, (SELECT x FROM ccvt WHERE x =
 ERROR:  subqueries are not allowed in a continuous view's target list
 HINT:  Stream-table joins are the preferred method for combining other relations with continuous views.
 DROP TABLE ccvt;
+-- Verify that step sizes are properly computed from step factors
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=0.1) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+ERROR:  sliding-window stepfactor must be an integer
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=102) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+ERROR:  sliding-window stepfactor must be an integer between 1 and 100
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=0) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+ERROR:  sliding-window stepfactor must be an integer between 1 and 100
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=50) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+SELECT pipeline_get_worker_querydef('ccvsf');
+                                        pipeline_get_worker_querydef                                         
+-------------------------------------------------------------------------------------------------------------
+  SELECT date_floor(arrival_timestamp::timestamp with time zone, '00:00:05'::interval) AS arrival_timestamp,+
+     count(*) AS count                                                                                      +
+    FROM ONLY stream                                                                                        +
+   WHERE (arrival_timestamp::timestamp with time zone > (clock_timestamp() - '00:00:10'::interval))         +
+   GROUP BY date_floor(arrival_timestamp::timestamp with time zone, '00:00:05'::interval)
+(1 row)
+
+DROP CONTINUOUS VIEW ccvsf;
+-- Verify that explicity truncation overrides the step factor
+CREATE CONTINUOUS VIEW ccvsf AS SELECT COUNT(*) FROM stream WHERE minute(arrival_timestamp) > clock_timestamp() - interval '10 seconds';
+SELECT pipeline_get_worker_querydef('ccvsf');
+                                        pipeline_get_worker_querydef                                        
+------------------------------------------------------------------------------------------------------------
+  SELECT minute(arrival_timestamp::timestamp with time zone) AS arrival_timestamp,                         +
+     count(*) AS count                                                                                     +
+    FROM ONLY stream                                                                                       +
+   WHERE (minute(arrival_timestamp::timestamp with time zone) > (clock_timestamp() - '00:00:10'::interval))+
+   GROUP BY minute(arrival_timestamp::timestamp with time zone)
+(1 row)
+
+DROP CONTINUOUS VIEW ccvsf;
 DROP CONTINUOUS VIEW cqcreate0;
 DROP CONTINUOUS VIEW cqcreate1;
 DROP CONTINUOUS VIEW cqcreate2;
diff --git a/src/test/regress/expected/hash_group.out b/src/test/regress/expected/hash_group.out
index 6af59b24e..b00f32130 100644
--- a/src/test/regress/expected/hash_group.out
+++ b/src/test/regress/expected/hash_group.out
@@ -155,8 +155,6 @@ FROM generate_series(1, 100) AS i ORDER BY key;
 -- Ensure that hash index is created and cannot be dropped
 CREATE CONTINUOUS VIEW hash_group AS SELECT x::int, COUNT(*) FROM hash_group_stream GROUP BY x;
 CREATE CONTINUOUS VIEW ls_hash_group1 AS SELECT x::int, minute(y::timestamptz), COUNT(*) FROM hash_group_stream WHERE ( arrival_timestamp > clock_timestamp() - interval '5 hour' ) GROUP BY x, minute;
-NOTICE:  window width is "5 hour" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE CONTINUOUS VIEW ls_hash_group2 AS SELECT x::int, y::timestamptz, COUNT(*) FROM hash_group_stream GROUP BY x, y;
 \d+ hash_group_mrel0;
                    Table "public.hash_group_mrel0"
diff --git a/src/test/regress/expected/pipeline_regress.out b/src/test/regress/expected/pipeline_regress.out
index 6698cf19c..f0f28a00e 100644
--- a/src/test/regress/expected/pipeline_regress.out
+++ b/src/test/regress/expected/pipeline_regress.out
@@ -37,8 +37,6 @@ CREATE CONTINUOUS VIEW test_view AS
     arrival_timestamp as ts
   FROM test_stream
   WHERE arrival_timestamp >= ( clock_timestamp() - interval '90 minutes' );
-NOTICE:  window width is "90 minutes" with a step size of "1 minute"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_stream (user_id, page_id) VALUES (1, 1);
 SELECT pg_sleep(1);
  pg_sleep 
@@ -66,8 +64,6 @@ LANGUAGE 'plpgsql' IMMUTABLE;
 CREATE CONTINUOUS VIEW test_view AS
   SELECT arrival_timestamp FROM test_stream
   WHERE arrival_timestamp > clock_timestamp() - interval '1 hour';
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_stream (x) VALUES (NULL);
 INSERT INTO test_stream (x) VALUES (NULL);
 SELECT COUNT(*) FROM test_view;
diff --git a/src/test/regress/expected/stream_table_join.out b/src/test/regress/expected/stream_table_join.out
index 0a443bea5..dafbb2d05 100644
--- a/src/test/regress/expected/stream_table_join.out
+++ b/src/test/regress/expected/stream_table_join.out
@@ -283,8 +283,6 @@ FROM test_stj_sw0_s s JOIN test_stj_sw0_t t
 USING (x)
 WHERE (s.arrival_timestamp > clock_timestamp() - interval '4 seconds')
 GROUP by s.x, s.y, t_x;
-NOTICE:  window width is "4 seconds" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO test_stj_sw0_s (x, y) SELECT x, x AS y FROM generate_series(0, 9) AS x;
 INSERT INTO test_stj_sw0_s (x, y) SELECT x, x AS y FROM generate_series(0, 9) AS x;
 INSERT INTO test_stj_sw0_s (x, y) SELECT x, x AS y FROM generate_series(0, 9) AS x;
diff --git a/src/test/regress/expected/sw_vacuum.out b/src/test/regress/expected/sw_vacuum.out
index 150e7c70d..4183cc8dd 100644
--- a/src/test/regress/expected/sw_vacuum.out
+++ b/src/test/regress/expected/sw_vacuum.out
@@ -1,6 +1,4 @@
 CREATE CONTINUOUS VIEW cqvacuum AS SELECT key::text, COUNT(*) FROM cqvacuum_stream WHERE arrival_timestamp > clock_timestamp() - interval '3 second' GROUP BY key;
-NOTICE:  window width is "3 second" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 INSERT INTO cqvacuum_stream (key) VALUES ('a'), ('b'), ('c');
 INSERT INTO cqvacuum_stream (key) VALUES ('a'), ('b'), ('c');
 SELECT pg_sleep(1);
diff --git a/src/test/regress/expected/user_combine.out b/src/test/regress/expected/user_combine.out
index 42b559845..fd2ab9947 100644
--- a/src/test/regress/expected/user_combine.out
+++ b/src/test/regress/expected/user_combine.out
@@ -45,8 +45,6 @@ SELECT date_trunc('minute', t::timestamptz) AS minute,
     FROM test_uc_systat_stream
 WHERE arrival_timestamp > (clock_timestamp() - interval '1 hour')
 GROUP BY minute;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE VIEW test_uc2_view AS
 SELECT minute, combine(load_avg) OVER (ORDER BY minute DESC ROWS 4 PRECEDING) AS load_avg
   FROM test_uc2;
@@ -926,8 +924,6 @@ SELECT date_trunc('minute', t::timestamptz) AS minute, avg(queue_length::float)
 FROM sysstat
 WHERE arrival_timestamp > clock_timestamp() - interval '1 hour'
 GROUP BY minute;
-NOTICE:  window width is "1 hour" with a step size of "1 second"
-HINT:  Use a datetime truncation function if you want to explicitly set the step size.
 CREATE VIEW over_5m AS
 SELECT first_value(minute) OVER w AS minute, combine(load_avg) OVER w AS load_avg
 FROM over_1m
diff --git a/src/test/regress/sql/create_cont_view.sql b/src/test/regress/sql/create_cont_view.sql
index b6784814c..f799a27c6 100644
--- a/src/test/regress/sql/create_cont_view.sql
+++ b/src/test/regress/sql/create_cont_view.sql
@@ -129,6 +129,24 @@ CREATE TABLE ccvt (x integer);
 CREATE CONTINUOUS VIEW noss AS SELECT y::integer, (SELECT x FROM ccvt WHERE x = 1) FROM stream;
 DROP TABLE ccvt;
 
+-- Verify that step sizes are properly computed from step factors
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=0.1) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=102) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=0) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+
+CREATE CONTINUOUS VIEW ccvsf WITH (stepfactor=50) AS SELECT COUNT(*) FROM stream WHERE arrival_timestamp > clock_timestamp() - interval '10 seconds';
+SELECT pipeline_get_worker_querydef('ccvsf');
+
+DROP CONTINUOUS VIEW ccvsf;
+
+-- Verify that explicity truncation overrides the step factor
+CREATE CONTINUOUS VIEW ccvsf AS SELECT COUNT(*) FROM stream WHERE minute(arrival_timestamp) > clock_timestamp() - interval '10 seconds';
+SELECT pipeline_get_worker_querydef('ccvsf');
+
+DROP CONTINUOUS VIEW ccvsf;
+
 DROP CONTINUOUS VIEW cqcreate0;
 DROP CONTINUOUS VIEW cqcreate1;
 DROP CONTINUOUS VIEW cqcreate2;
